Summary: The SQUID proxy caching server.
Name: squid
Version: 2.4.STABLE7
Release: 5ml
%if !%{FHS}
Serial: 2004042201
%endif
Copyright: GPL
Group: Server/Network
Source: http://www.squid-cache.org/Versions/v2/2.4/squid-%{version}-src.tar.gz
Source1: ftp://squid.nlanr.net/web/Squid/FAQ/FAQ.sgml
Source2: squid.init
Source3: squid.logrotate
Patch0: squid-2.4.STABLE4.makefile.patch
Patch1: squid-2.4.STABLE4.config.patch
Patch2: squid-2.3.STABLE5.perlpath.patch
# Patch4: squid-2.4.STABLE6-transfer.patch
# Patch5: squid-2.4.STABLE6-msnt.patch
Patch6: squid-2.4.STABLE7-msntauth.patch
Patch7: squid-2.4.STABLE7-url_port.patch
Patch8: squid-2.4.STABLE7-url_escape.patch
Patch9: squid-2.4.STABLE6-urllogin_acl.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Prereq: /sbin/chkconfig shadow-utils
Obsoletes: squid-novm
#NoSource: 0

%description
Squid is a high-performance proxy caching server for web clients, supporting
FTP, gopher, and HTTP data objects. Unlike traditional caching software,
Squid handles all requests in a single, non-blocking, I/O-driven process.

Squid keeps meta data and especially hot objects cached in RAM, caches DNS
lookups, supports non-blocking DNS lookups, and implements negative caching
of failed requests.

Squid supports SSL, extensive access controls, and full request logging. By
using the lightweight Internet Cache Protocol, Squid caches can be arranged
in a hierarchy or mesh for additional bandwidth savings.

Squid consists of a main server program squid, a Domain Name System lookup
program dnsserver, a program for retrieving FTP data ftpget, and some
management and client tools. When squid starts up, it spawns a configurable
number of dnsserver processes, each of which can perform a single, blocking
Domain Name System (DNS) lookup. This reduces the amount of time the cache
waits for DNS lookups.

Squid is derived from the ARPA-funded Harvest project.

%prep
%setup
%patch0 -p1 -b .makefile
%patch1 -p1 -b .config
%patch2 -p1 -b .perlpath
#%patch3 -p1 -b .ftpcrash
# %patch4 -p1 -b .transfer
# %patch5 -p1 -b .msnt
%patch6 -p1 -b .msntauth
%patch7 -p1 -b .urlport
%patch8 -p1 -b .urlescape
%patch9 -p1 -b .urllogin_acl

#%patch10 -p1 -b .erros

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
   --exec_prefix=/usr --bindir=/usr/sbin --libexecdir=/usr/lib/squid \
   --localstatedir=/var --sysconfdir=/etc/squid \
   --enable-poll --enable-snmp # --enable-icmp
#make CC="gcc -V2.7.2.3SG" -f makefile
make -f makefile

mkdir faq
cp $RPM_SOURCE_DIR/FAQ.sgml faq
cd faq 
#sgml2html FAQ.sgml

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr
make install  \
	prefix=$RPM_BUILD_ROOT/usr \
	sysconfdir=$RPM_BUILD_ROOT/etc/squid \
	localstatedir=$RPM_BUILD_ROOT/var \
	bindir=$RPM_BUILD_ROOT/usr/sbin \
	libexecdir=$RPM_BUILD_ROOT/usr/lib/squid
#install -m 4750 src/pinger $RPM_BUILD_ROOT/usr/lib/squid
gzip -9 faq/* CONTRIBUTORS COPYING COPYRIGHT CREDITS ChangeLog INSTALL QUICKSTART README TODO doc/*.txt

cd errors
rm -rf $RPM_BUILD_ROOT/etc/squid/errors
mkdir -p $RPM_BUILD_ROOT/usr/lib/squid/errors
for i in *; do
   if [ -d $i ]; then
       mkdir -p $RPM_BUILD_ROOT/usr/lib/squid/errors/$i
       install -m 644 $i/* $RPM_BUILD_ROOT/usr/lib/squid/errors/$i
   fi
done
ln -s /usr/lib/squid/errors/English $RPM_BUILD_ROOT/etc/squid/errors

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 $RPM_SOURCE_DIR/squid.init $RPM_BUILD_ROOT/etc/rc.d/init.d/squid

mkdir -p $RPM_BUILD_ROOT/var/log/squid
mkdir -p $RPM_BUILD_ROOT/var/spool/squid

strip $RPM_BUILD_ROOT/usr/bin/* $RPM_BUILD_ROOT/usr/sbin/* \
      $RPM_BUILD_ROOT/usr/lib/squid/* || :
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m 0644 $RPM_SOURCE_DIR/squid.logrotate \
		$RPM_BUILD_ROOT/etc/logrotate.d/squid

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%config (noreplace) /etc/squid/squid.conf
%config (noreplace) /etc/squid/mime.conf
%config (noreplace) /etc/squid/mib.txt
/etc/squid/squid.conf.default
/etc/squid/mime.conf.default
/etc/squid/errors
/usr/lib/squid/errors
/usr/lib/squid/icons
/usr/lib/squid/dnsserver
/usr/lib/squid/unlinkd
#%attr(4750,root,squid) /usr/lib/squid/pinger
/usr/sbin/squid
/usr/sbin/client
/usr/lib/squid/cachemgr.cgi
%config (noreplace) /etc/rc.d/init.d/squid
%config (noreplace) /etc/logrotate.d/squid
%doc faq/* CONTRIBUTORS.gz COPYING.gz COPYRIGHT.gz CREDITS.gz ChangeLog.gz
%doc INSTALL.gz QUICKSTART.gz README.gz TODO.gz doc/*
%doc contrib/url-normalizer.pl contrib/rredir.* contrib/user-agents.pl

%attr(750,squid,squid) %dir /var/log/squid
%attr(750,squid,squid) %dir /var/spool/squid

%pre
/usr/sbin/useradd -d /var/spool/squid -r -s /dev/null squid >/dev/null 2>&1

for i in /var/{log/squid,spool/squid} ; do
	if [ -d $i ] ; then
		for adir in `find $i -maxdepth 0 \! -user squid`; do
			chown -R squid.squid $adir
		done
	fi
done

exit 0

%post
/sbin/chkconfig --add squid
if [ $1 = 0 ]; then
 case "$LANG" in
  bg*)
     DIR=Bulgarian
     ;;
  cs*)
     DIR=Czech
     ;;
  nl*)
     DIR=Dutch
     ;;
  ea*)
     DIR=Estonian
     ;;
  fr*)
     DIR=French
     ;;
  de*)
     DIR=German
     ;;
  en*)
     DIR=English
     ;;
  hu*)
     DIR=Hungarian
     ;;
  it*)
     DIR=Italian
     ;;
  ja*)
     DIR=Japanese
     ;;
  pl*)
     DIR=Polish
     ;;
  pt*)
     DIR=Portuguese
     ;;
  ru*)
     DIR=Russian-koi8-r
     ;;
  sk*)
     DIR=Slovak
     ;;
  es*)
     DIR=Spanish
     ;;
  zh*)
     DIR=Traditional_Chinese
     ;;
  tr*)
     DIR=Turkish
     ;;
  *)
     DIR=English
     ;;
 esac
 ln -snf /usr/lib/squid/errors/$DIR /etc/squid/errors
fi

%preun
if [ $1 = 0 ] ; then
	/etc/rc.d/init.d/squid stop
	rm -f /var/log/squid/*
	rm -rf /var/spool/squid/*
	/sbin/chkconfig --del squid
fi

%postun
if [ $1 = 0 ] ; then
	userdel squid
fi


%changelog
* Wed Apr 21 2004 Hideo Takeuchi <takeuchi@miraclelinux.com>
- protecting vulnerable clients (urllogin_acl.patch)

* Mon Aug 11 2003 Daisuke Tonoki <tonoki@miraclelinux.com>
- buffer overrun (url_escape.patch)
- assertion failure (url_port.patch)
- fix two bugs. patches from squid-cache.org.

* Wed Oct 16 2002 Daisuke Tonoki <tonoki@miraclelinux.com>
- add missingok line to logrotate file.

* Tue Jul 9 2002 Daisuke Tonoki <tonoki@miraclelinux.com>
- update to 2.4.STABLE7 and msntauth Patch

* Fri Jun 28 2002 Daisuke Tonoki <tonoki@miraclelinux.com>
- add credentials forwarding contorol patch

* Mon Jun 10 2002 Daisuke Tonoki <tonoki@miraclelinux.com>
- add logrotate support file
- add MSNT auth helper patch

* Tue Apr  9 2002 Takeharu SATO <tsatoh@miraclelinux.com>
- upgraded to 2.4-STABLE6 due to "Compressed DNS Buffer Overflow Vulnerability"
- which reported as bugtraq id #4363 in SecurityFocus

* Mon Mar  4 2002 Jun YOSHIDA <jun@miraclelinux.com>
- upgraded to 2.4-STABLE4 due to some security issues.

* Tue Nov 13 2001 Jun YOSHIDA <jun@miraclelinux.com>
- should have added Serial TAG for ML1.x.

* Mon Nov 12 2001 Jun YOSHIDA <jun@miraclelinux.com>
- added patch to fix ftp crash security hole.

* Thu Aug 30 2001 Jun YOSHIDA <jun@miraclelinux.com>
- moved squid.logrotate from /etc/logrotate.d to %{_docdir}.

* Mon Jul 30 2001 Jun YOSHIDA <jun@miraclelinux.com>
- updated to version 2.3STABLE5 to solve security hole problem.

* Fri Jan 12 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated to version 2.3STABLE4.
- Added mktemp patch for  /tmp file race condition vulnerability.

* Wed Mar 29 2000 Takeshi Aihana <takeshi@turbolinux.co.jp>
- rebuild with gcc SG

* Mon Nov 1 1999 Roger Luethi <rluethi@turbolinux.com>
- update to 2.2STABLE5
- removed obsolete patches, added patches from
  http://www.squid-cache.org/Versions/v2/2.2/bugs/
  (full description on web page mentioned above)
- added (noreplace) for config files
- removed "/sbin/chkconfig --add squid" from %post
- added and gzipped documentation
- /var/sppol/squid is removed on uninstall (it's only a cache, after all)
- squid is stopped on uninstall

* Fri Aug 6 1999 Anh Vo <anhvo@turbolinux.com>
- Built for TL

* Wed Jul 28 1999 Bill Nottingham <notting@redhat.com>
- put cachemgr.cgi back in /usr/lib/squid

* Wed Jul 14 1999 Bill Nottingham <notting@redhat.com>
- add webdav bugfix patch (#4027)

* Mon Jul 12 1999 Bill Nottingham <notting@redhat.com>
- fix path to config in squid.init (confuses linuxconf)

* Wed Jul  7 1999 Bill Nottingham <notting@redhat.com>
- 2.2.STABLE4

* Wed Jun 9 1999 Dale Lovelace <dale@redhat.com>
- logrotate changes
- errors from find when /var/spool/squid or
- /var/log/squid didn't exist

* Thu May 20 1999 Bill Nottingham <notting@redhat.com>
- 2.2.STABLE3

* Thu Apr 22 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.STABLE.2

* Sun Apr 18 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.STABLE1

* Thu Apr 15 1999 Bill Nottingham <notting@redhat.com>
- don't need to run groupdel on remove
- fix useradd

* Mon Apr 12 1999 Bill Nottingham <notting@redhat.com>
- fix effective_user (bug #2124)

* Mon Apr  5 1999 Bill Nottingham <notting@redhat.com>
- strip binaries

* Thu Apr  1 1999 Bill Nottingham <notting@redhat.com>
- duh. adduser does require a user name.
- add a serial number

* Tue Mar 30 1999 Bill Nottingham <notting@redhat.com>
- add an adduser in %pre, too

* Thu Mar 25 1999 Bill Nottingham <notting@redhat.com>
- oog. chkconfig must be in %preun, not %postun

* Wed Mar 24 1999 Bill Nottingham <notting@redhat.com>
- switch to using group squid
- turn off icmp (insecure)
- update to 2.2.DEVEL3
- build FAQ docs from source

* Tue Mar 23 1999 Bill Nottingham <notting@redhat.com>
- logrotate changes

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Wed Feb 10 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.PRE2

* Wed Dec 30 1998 Bill Nottingham <notting@redhat.com>
- cache & log dirs shouldn't be world readable
- remove preun script (leave logs & cache @ uninstall)

* Tue Dec 29 1998 Bill Nottingham <notting@redhat.com>
- fix initscript to get cache_dir correct

* Fri Dec 18 1998 Bill Nottingham <notting@redhat.com>
- update to 2.1.PATCH2
- merge in some changes from RHCN version

* Sat Oct 10 1998 Cristian Gafton <gafton@redhat.com>
- strip binaries
- version 1.1.22

* Sun May 10 1998 Cristian Gafton <gafton@redhat.com>
- don't make packages conflict with each other...

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- added a proxy auth patch from Alex deVries <adevries@engsoc.carleton.ca>
- fixed initscripts

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- rebuilt for Manhattan

* Fri Mar 20 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 1.1.21/1.NOVM.21

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- updated the init script to use reconfigure option to restart squid instead
  of shutdown/restart (both safer and quicker)

* Sat Feb 07 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 1.1.20
- added the NOVM package and tryied to reduce the mess in the spec file

* Wed Jan 7 1998 Cristian Gafton <gafton@redhat.com>
- first build against glibc
- patched out the use of setresuid(), which is available only on kernels
  2.1.44 and later

